#include "Vram.h"
#include "Chars.h"

extern byte[] MonoChars, BackChars, Ascii;


void InitVram()
{
    MakePatternMono(Char_Ascii, Ascii, 0x40, 7);
    MakePatternMono(
        Char_Logo, 
        MonoChars + (Char_Logo - Char_Logo) * CharHeight, 
        Char_Man - Char_Logo, 2
    );
    MakePatternMono(
        Char_Man, 
        MonoChars + (Char_Man - Char_Logo) * CharHeight, 
        Char_Fire - Char_Man, 
        3
    );
    MakePatternMono(
        Char_Fire, 
        MonoChars + (Char_Fire - Char_Logo) * CharHeight, 
        Char_Item_1Up - Char_Fire, 
        1
    );
    MakePatternMono(
        Char_Item_1Up, 
        MonoChars + (Char_Item_1Up - Char_Logo) * CharHeight, 
        Char_End - Char_Item_1Up, 
        2
    );
    MakePatternBack(
        BChar_Space,
        BackChars,
        BChar_End - BChar_Space
    );
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


void Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}
