ext  @Temp@Word

include "bios.inc"
include "subbin.inc"
include "Vram.inc"
include "VVram.inc"
include "Chars.inc"
include "share.inc"

Bank equ $fd0f
SharedRam equ $FC80

VramTop equ Vram

ext VVramFront_, VVramBack_
ext SendSubsys, HaltSubsys, ResumeSubsys, WaitSubsys, WriteSharedRam

dseg
BackupBack:
    defs VVramSize
BackupFront:
    defs VVramSize

zseg
planeCount:
    defb 0    
yCount:
    defb 0
byteCount:
    defb 0
bitCount:
    defb 0
charColor:
    defb 0
invertedByte:
    defb 0

VVramToVram_yCount:
    defb 0
VVramToVram_xCount:
    defb 0
VVramToVram_vram:
    defw 0
VVramToVram_pFlags:
    defw 0
VVramToVram_flags:
    defb 0
VVramToVram_mask:
    defb 0


; void MakePatternMono(byte c, ptr<byte> pSource, byte count, byte color);
dseg
MakePatternMono_@Param2: public MakePatternMono_@Param2
MakePatternMono_count:
    defb 0
MakePatternMono_@Param3: public MakePatternMono_@Param3
MakePatternMono_color:
    defb 0
cseg
MakePatternMono_: public MakePatternMono_
    pshs a,b,x,y
        orcc #$50
        sta Bank

        ldb #FrontPatternSize
        mul
        addd #PatternRamFront
        tfr d,x

        do
            lda MakePatternMono_color
            sta charColor

            lda #2
            sta <planeCount
            do
                pshs y
                    lda #CharHeight
                    sta <yCount
                    do
                        clrb
                        lda charColor
                        bita #$01
                        if ne
                            orb ,y
                        endif
                        bita #$10
                        if ne
                            lda ,y
                            coma
                            sta <invertedByte
                            orb <invertedByte
                        endif
                        lda #2
                        sta <byteCount
                        do
                            lda #4
                            sta <bitCount
                            clra
                            do
                                lsla
                                lsla
                                lslb
                                if cs
                                    ora #$03
                                endif
                                dec <bitCount
                            while ne | wend
                            sta ,x+
                            dec <byteCount
                        while ne | wend
                        leay 1,y
                        dec <yCount
                    while ne | wend
                puls y
                lsr <charColor
                dec <planeCount
            while ne | wend
            leay CharHeight,y
            dec MakePatternMono_count
        while ne | wend
        lda Bank
        andcc #not $50
    puls a,b,x,y
rts


; void MakePatternBack(byte c, ptr<byte> pSource, byte count);
dseg
MakePatternBack_@Param2: public MakePatternBack_@Param2
MakePatternBack_count:
    defb 0
cseg
MakePatternBack_: public MakePatternBack_
    pshs a,b,x,y
        orcc #$50
        sta Bank

        ldb #BackPatternSize
        mul
        addd #PatternRamBack
        tfr d,x
        do
            lda #CharHeight
            sta <yCount
            do
                ldb ,y+
                lda #2
                sta <byteCount
                do
                    lda #4
                    sta <bitCount
                    clra
                    do
                        lsla
                        lsla
                        lslb
                        if cs
                            ora #$03
                        endif
                        dec <bitCount
                    while ne | wend
                    sta ,x+
                    dec <byteCount
                while ne | wend
                dec <yCount
            while ne | wend
            dec MakePatternBack_count
        while ne | wend
        lda Bank
        andcc #not $50
    puls a,b,x,y
rts


; void StartSubMain();
cseg
SubMain_Command:
    defb 0,0
    defb SUB.TEST
    defb 'YAMAUCHI'
    defb $93
    defw SubMain
    defb $90
StartSubMain_: public StartSubMain_
    pshs x,b,a
        ldx #SubMain_Command
        ldb #StartSubMain_-SubMain_Command
        jsr SendSubsys
    puls x,b,a
rts


Halt:
    pshs a
        HaltLoop:
        do
            lda $FD05
        while mi | wend
        orcc #$50
        lda #$80
        sta $FD05
        tst SharedRam
        if ne
            clr $FD05
            andcc #not $50
            bra HaltLoop
        endif
    puls a
rts

Resume:
    clr $FD05
    andcc #not $50
rts

; void ClearScreen();
; ClearScreen_Command:
;     defb 0,0
;     defb SUB.ERASE
;     defb 0,0
ClearScreen_:   public ClearScreen_
    pshs x,b,a
        jsr Halt
        lda #SubCommand_Clear
        sta SharedRam+Share_Command
        jsr Resume
        clr lastChar

        ldx #BackupBack
        ldd #VVramSize*2
        do
            clr ,x+
            subd #1
        while ne | wend
    puls x,b,a
rts


; word Put(word vram, byte c);
dseg
    lastChar: defb 0
cseg
Put_: public Put_
    pshs a,b,x,y
        orcc #$40
        jsr Halt
        lda #SubCommand_PutFront | sta SharedRam+Share_Command
        stx SharedRam+Share_Address
        cmpb lastChar
        if ne
            stb lastChar
            lda #FrontPatternSize
            mul
            addd #PatternRamFront
            tfr d,x
            pshs cc | orcc #$50
                sta Bank
                    ldy #SharedRam+Share_Pattern
                    ldb #FrontPatternSize
                    do
                        lda ,x+
                        sta ,y+
                        decb
                    while ne | wend
                lda Bank
            puls cc
        endif
        jsr Resume
    puls a,b,x,y
    tfr	x,d
    addd #2
rts


; void VVramToVram();
VVramToVram_: public VVramToVram_
    pshs a,b,x,y
        ldx #VramTop
        stx <VVramToVram_vram
        ldx #VVramBack_
        ldy #BackupBack
        lda #VVramHeight
        sta <VVramToVram_yCount
        do
            lda #VVramWidth
            sta <VVramToVram_xCount
            do 
                ldb ,x
                cmpb ,y
                if ne
                    stb ,y
                    pshs x,y
                        orcc #$40
                        jsr Halt
                        ldy #SharedRam
                        lda #SubCommand_PutBack | sta ,y+
                        ldx <VVramToVram_vram
                        stx ,y++
                        stb ,y
                        jsr Resume
                    puls x,y
                endif

                ldb VVramSize,x
                cmpb VVramSize,y
                if ne
                    stb VVramSize,y
                    pshs x
                        ldx <VVramToVram_vram
                        bsr Put_
                    puls x
                endif
                leax 1,x
                leay 1,y
                pshs x
                    ldx <VVramToVram_vram
                    leax 2,x
                    stx <VVramToVram_vram
                puls x
                dec <VVramToVram_xCount
            while ne | wend
            pshs x
                ldx <VVramToVram_vram
                leax VramRowSize-VVramWidth*2,x
                stx <VVramToVram_vram
            puls x
            dec <VVramToVram_yCount
        while ne | wend
    puls a,b,x,y
rts
